
var _itemArray; // = new Array(); // Global 変数
var _groupCode; // = new Array(); // Global 変数

function initItemArray(){
	_itemArray = new Array();
}
function setItemArray(array){
    _itemArray = array;
}
function itemArray(){
    return _itemArray;
}
function addItemArray(item){
	_itemArray.push(item);
}
function removeItemArray(number){
	for (var i=_itemArray.length-1; i >= 0; i--){
		var _item = _itemArray[i];
		if (number == _item.number) _itemArray.splice(i, 1);
	}
}
function countOfItemArray(){
	return _itemArray.length;
}
function itemAtIndexOf(ix){
	// itemArray の ix 番目の item を返す
	return (ix < _itemArray.length) ? _itemArray[ix] : null;
}
function itemWithId(number){
	// number を ID とする item を返す
	var count = _itemArray.length;
	for (var i=0; i < count; i++){
		var item = _itemArray[i];
		if (item.number == number) return item;
	}
	return null;
}

var _currentRecords; // = new Array(); // Global 変数
function setCurrentRecords(array){
	// 現在選択されているレコードの値を記憶
	_currentRecords = array;
}
function currentRecords(){
	return _currentRecords;
}

function groupCode(){
	// 診療行為のコード番号を返す
	return _groupCode;
}
function setGroupCode(code){
	// 診療行為の種類が選択された
	if (_groupCode){
		var elm = document.getElementById("item:"+_groupCode);
		elm.style.backgroundColor="#bfe";
		elm.style.color="#000";
	}
	
	_groupCode = code;
	var elm = document.getElementById("item:"+code);
	elm.style.backgroundColor="#00f";
	elm.style.color="#ffa";
	
	getItemList(code);
}

var _medicalActions;
function setMedicalActions(obj){
    _medicalActions = obj;
}
function medicalActions(){
    // 診療行為メニュー・オブジェクトを返す
    return _medicalActions;
}

//////////////////////////////////
///// HospitalTable からの継承値 ///

var _round; // Global 変数
var _ownRate; // Global 変数
function setHospitalInfo(obj){
	// obj = "round(5)ownRate(20)"
    _round = obj.round;
    _ownRate = obj.ownRage;
}

function marume(val){
	return Math.floor((val + _round) / 10) * 10;
}

function ownRate(){
	// 自費料金を計算するための点数への掛け率
	return _ownRate;
}

///// HospitalTable からの継承値 ///
//////////////////////////////////



/////////////////////////
///// カルテからの継承値 ///

function args(){
	// patientId, ageOfTheMoon
	// を vinServer へ渡すための変数パッケージ
	var array = new Array();
	array['owner'] = parent().owner();
	array['patientId'] = parent().patientId();
	array['entryDate'] = parent().currentDate();
	array['age'] = ageOfTheMoon();
	var elm = document.getElementById("timeZone");
	array['timeZone'] = (elm) ? elm.value : "";
	return array;
	
	function ageOfTheMoon(){
		// patientId と本日の年月日から年齢を計算して返す
		var pid = parent().patientId();
		var yy = pid.substr(4,2) * 1;
		var yyyy = (yy > 25) ? 1900 + yy : 2000 + yy;
		var mm = pid.substr(0,2) * 1;
		var dd = pid.substr(2,2) * 1;
		var birthDate = yyyy + "-" + mm + "-" + dd;

		return ageAtDate(birthDate, parent().currentDate());
	}
}

///// カルテからの継承値 ///
/////////////////////////


///////////////////////////////////////
///// レコードの文字列化はここで管理     ///
///// vin.php 側では newItem() で管理 ///

function archives(){
	// itemArray を 診療行為の表示行 に変換して返す
    // 「テンプレート登録」に使う
    _debug("== archives =="); //##
    var results = new Array();
    var array = treatmentArray();
    if (array.length > 0){
        for (num in array){
            var rec = array[num];
            var ln = treatmentFormat(rec);
            results.push(ln);
        }
    }
    return results.join("\n");
}

function treatmentArray(){
	// itemArray を 診療行為オブジェクトの配列 に変換して返す
    // 「サーバへ計算依頼」に使う
	var array = new Array();
	var count = countOfItemArray();
	if (count > 0){
        var items = itemArray();
        for (num in items){
            var item = items[num];
            if (item.code % 10 == 9) continue; // 自動付加行はスキップ
            if (item.code * 1 == 13) continue; // 自動付加行はスキップ
            
            array.push(encodeItemObj(item));
        }
    }
    //_debug("treatmentArray->"+encodeObject(array)); //##
    
	return array;
    

    function encodeItemObj(item){
        // item を 診療行為オブジェクト に変換して返す
        //alert("encodeItem->"+encodeObject(item)); //##
        
        var rec = new Object();
        rec.number = item.number;
        rec.isOwn = (item.isOwn * 1 > 0) ? 1 : 0;
        rec.code = item.code;
        rec.alias = item.alias;
        rec.name = item.name;
        rec.dose = item.dose;
        rec.standard = item.dose;
        if ((rec.standard.length == 0) || (rec.standard * 1 == 0))
            rec.standard = 1;
        rec.unitName = item.unitName;
        rec.freq = item.freq;
        rec.point = item.point; // 空データの場合は calc() 時にサーバ側で PriceList から補完
        rec.isMix = item.isMix;
        rec.editable = 0;
        
        // 名前の頭に "+ " があれば混注
        if (item.name.indexOf("+ ") >= 0){
            rec.isMix = "1";
            rec.name = item.name.substr(2);
        }
        
        return rec;
    }
}

function codeArray(){
    // コード番号の配列を返す
    return [11,12,13,21,22,23,29,31,32,33,41,48,51,52,58,60,69,70,80,90,91];
}
function codeName(code){
    // ### vinServer.js の codeName() と同じであること ###
    switch (code * 1){
        case 11: return "初診";
        case 12: return "再診";
        case 13: return "診他";
        case 21: return "内服";
        case 22: return "屯服";
        case 23: return "外用";
        case 29: return "薬加";
        case 31: return "皮注";
        case 32: return "静注";
        case 33: return "点滴";
        case 41: return "処置";
        case 48: return "処薬";
        case 51: return "手術";
        case 52: return "麻酔";
        case 58: return "手薬";
        case 60: return "検査";
        case 69: return "判断";
        case 70: return "画像";
        case 80: return "其他";
        case 90: return "入院";
        case 91: return "入他";
        default: return "";
    }
}
function codeForName(name){
    // name に対応する code を返す
    var array = codeArray();
    for (num in array){
        var code = array[num];
        var nm = codeName(code);
        if (name == nm) return code;
    }
    return 0;
}

function newItem(rec){
    // rec = isOwnFee(0)code(11)alias()name(初診)dose()unitName()freq(1)point(270)isMix()
	// アイテム属性を記憶した Item Class を生成し itemArray に保存
    //_debug("== newItem->"+encodeObject(rec)); //##
    
	var item = new Object();
	var number = countOfItemArray();
    
	item.number = number; // item の ID (必ずしも itemArray 中の順番ではない)
	item.subItems = new Array();
	item.isOwn = rec.isOwn; // ####
	item.code = rec.code;
	item.alias = rec.alias;
	item.name = rec.name;
	item.dose = (rec.dose * 1 > 0) ? rec.dose : 1;;
	item.standard = (rec.standard * 1 > 0) ? rec.standard : 1;
	item.unitName = rec.unitName;
	item.freq = (rec.freq * 1 > 0) ? rec.freq : 1;;
	item.point = rec.point; // 空データの場合は calc() 時にサーバ側で PriceList から補完
	item.isMix = rec.isMix;
	item.editable = 0;

    // 名前の頭に "+ " があれば混注
    if (item.name.indexOf("+ ") >= 0){
        item.isMix = "1";
        item.name = item.name.substr(2);
    }
    
	addItemArray(item); // number を取り出した後で実行すること

	return item;
}

function doseChanged(row){
    // row 行目のレコードの単位数が変更された
    var item = itemAtIndexOf(row);
    item.dose = document.getElementById(row + ".dose").value;
}

function freqChanged(row){
    // row 行目のレコードの回数が変更された
    var item = itemAtIndexOf(row);
    item.freq = document.getElementById(row + ".freq").value;
}

///// レコードの文字列化はここで管理 ///
///////////////////////////////////

///////////////////////////////////
/// localStorage による処理 /////////

/// localStorage による処理 /////////
///////////////////////////////////

///////////////////////////////////
///// Ajax による処理 ///////////////

function savedTemplate(){
	// テンプレートが保存された後の処理
	if ((xmlHttpObject.readyState == 4) && (xmlHttpObject.status == 200)){
		var value = xmlHttpObject.responseText;
		var array = value.split("<SEPARATOR>");
		if (array.length > 1){
			//alert(array[1]);
			// どういう訳かこのままではテンプレート更新が反映されないので reload
			window.location.reload(true); // 強制的にページを再表示
		}
		document.getElementById("message").innerHTML = "";
	}
	else 
		document.getElementById("message").innerHTML = "Loading...";
}
function saveTemplate(){
    _debug("== saveTemplate =="); //##
    
    // 一括メニュー・ポップアップが表示されていれば選択された一括メニュー項目を取得
	var elm = document.getElementById("itemSelector");
	var itemName = (elm) ? elm.value : "";
    _debug("itemName->"+itemName); //##

	var title = document.getElementById("templateName").value;
    _debug("title->"+title); //##
    
	if (title.length == 0){
		alert("テンプレート名を入れてから登録してください");
		return;
	} else if (itemName && isSame(itemName, title)){
		if (!confirm("同名テンプレートを上書きしていいですか？")) return;
	}
    
	// 現在表示されているレコード・セットをテンプレートとして登録
	xmlHttpObject = createXMLHttpRequest(savedTemplate);
	if (xmlHttpObject){ // GETパラメータ付きでリクエスト送信
        var obj = new Object();
        obj.owner = parent().owner();
        obj.title = title;
        obj.records = archives();
        var buff = encodeObject(obj);
        
        alert("archives->"+obj.records); //##
        
		var st = "./vinServer.php?command=PUT_TREATMENT_GROUP"
        + "&value="+encodeSTRING(buff);
/*
		+ "&alias="+title
		+ "&value="+encodeSTRING(archives())
		+ args();
*/
        _debug("PUT_TREATMENT_GROUP->"+st); return; //##

		xmlHttpObject.open("GET", encodeURI(st), true);
		xmlHttpObject.send(null);
	}
}

function getTimeZone(buff){
	// ",,0000,0600,深夜^,,2200,2400,深夜^,日,0000,2400" 形式を解析して時間区分を返す
    //_debug("getTimeZone->"+buff); //##
    
	var year = parent().currentDate().substr(0, 4);
	var month = parent().currentDate().substr(5, 2);
	var day = parent().currentDate().substr(8, 2);
	var date = new Date(year, month - 1, day);
	var d = date.getDay();
	var week = _weeks[d];
	var weekNum = Math.ceil(day / 7);
	var hour = parent().currentDate().substr(11, 2);
	var min = parent().currentDate().substr(14, 2);
	var time = hour + min;
	
	// 指定した日時の時間区分をチェックする
	var array = decodeCSV(buff);
    for (row in array){
		var obj = array[row];
		var result = timeZone(obj,weekNum,week,time);
		if (result.length > 0){
			return result;
		}
	}
	return "時間外";
	
	function timeZone(obj, weekNum, week, time){
		// 時間区分を返す
		if (obj.num)
			if (obj.num != weekNum) return "";
		if (obj.week)
			if (obj.week != week) return "";
		if (obj.from > time)
			return "";
		if (obj.to < time)
			return "";
		return obj.timeZone;
	}
	
	function decodeCSV(csv){
		// csv を conditions オブジェクトへ変換
		var results = new Array();
		var array = csv.split("^");
        for (row in array){
			var ln = trim(array[row]);
            
			var ary = ln.split(",");
			if (ary.length == 5){
				var obj = new Object();
				obj.weekNum = ary[0];
				obj.week = ary[1];
				obj.from = ary[2];
				obj.to = ary[3];
				obj.timeZone = ary[4];
				results.push(obj);
			}
		}
		
		if (results.length == 0){
			// csv に解析できるものがなければ default 条件を生成定
			var obj = new Array();
			obj.from = "0000";
			obj.to = "0600";
			obj.timeZone = "深夜";
			results.push(obj);
			
			var obj = new Array();
			obj.from = "2200";
			obj.to = "2400";
			obj.timeZone = "深夜";
			results.push(obj);
			
			var obj = new Array();
			obj.week = "日";
			obj.from = "0000";
			obj.to = "2400";
			obj.timeZone = "休日";
			results.push(obj);
			
			var obj = new Array();
			obj.from = "0900";
			obj.to = "1200";
			obj.timeZone = "時間内";
			results.push(obj);
		}
		
		return results;
	}
}

/////////////////////////////////////////////////////////////
///// Ajax: VIN は独立して動くので LOGIC:neuron.js の部分を内部に持つ

function setItemMatrix(elm, action){
    // 診療行為マトリックスを生成：vinCalcChecker.js からも利用される
    // obj = 一括(00) 初診(11) 再診(12) 診他(13) 内服(21) 屯服(22) 外用(23) 薬加(29) 皮注(31) 静注(32) 点滴(33) 処置(41) 処薬(48) 手術(51) 麻酔(52) 手薬(58) 検査(60) 判断(69) 画像(70) 其他(80) 入院(90) 入他(91)
    var obj = medicalActions().itemMatrix;
    var ul = newUL(elm, "");
    ul.setAttribute("class", "listMembers");
    for (key in obj){
        var code = obj[key];
        var li = newLI(ul, key);
        li.setAttribute("id", "item:"+code);
        li.setAttribute("class", "blueButton");
        li.setAttribute("onclick", action + "('" + code + "')");
    }
}

function gotCheckList(answer){
    var obj = JSON.parse(answer);
    setCheckList(obj); // vinCalcChecker.js
    
    // フィルターを読み込んでおく
    getFiter();
}
function putHeader(answer){
	// サーバから返されたヘッダー部分を表示
    //_initDebug(true); //##
    _debug("== putHeader"); //##
    
    initItemArray();
    var obj = JSON.parse(answer);
    setMedicalActions(obj);
    
    _debug("obj->"+encodeObject(obj)); //##
    
    // 診療行為マトリックスを表示
    var elm = document.getElementById("matrixArea");
    setItemMatrix(elm, "setGroupCode");
    
    // 診療時間帯ポップアップメニューを表示
    var timeZone = getTimeZone(obj.timeZone);
    //_debug("timeZone->"+timeZone); //##
    setTimeZonePopup(timeZone); //## とりあえず
    
    // hospitalTable などから施設固有値を得る: まるめ係数・自費係数
    setHospitalInfo(obj.hospitalInfo);
    
    // カルテが記憶していた診療行為セットを itemArray にセット
    var itemList = obj.itemList;
    if (itemList.length > 0){
        for (num in itemList){
            var rec = itemList[num];
            // この中の point はカルテの treatment フィールドから
            // 読み出されたものなので point * dose 処理がされている
            // ln:静注[ピドキサール注１０ｍｇ(1 管) 混注] 6
            
            newItem(rec);
        }
        showItemList();
    }

    // 病名チェッカーのチェックリストを読み込む
    NRGetDiseaseFromPriceList(null, gotCheckList);

	
	function setTimeZonePopup(currentTimeZone){
		// 診療行為ポップアップメニューを生成
		var array = ["時間内","時間外","休日","深夜"];
		var elm = document.getElementById("timeZoneArea");
		var pu = newPopupMenu(elm, "timeZone", array, currentTimeZone);
	}
}
function getHeader(){
	// onload で起動されるアクション：サーバにヘッダー部分の生成を依頼し表示
    NRGetVinHeader(container(), putHeader);

    function container(){
        // vinServer へ渡すための変数パッケージ
        var obj = new Object();
        obj['owner'] = parent().owner();
        obj['hospitalId'] = parent().hospitalId();
        obj['patientId'] = parent().patientId();
        obj['entryDate'] = parent().currentDate();
        obj['age'] = ageOfTheMoon();
        var elm = document.getElementById("timeZone");
        obj['timeZone'] = (elm) ? elm.value : "";
        return obj;
        
        function ageOfTheMoon(){
            // patientId と本日の年月日から年齢を計算して返す
            var pid = parent().patientId();
            var yy = pid.substr(4,2) * 1;
            var yyyy = (yy > 25) ? 1900 + yy : 2000 + yy;
            var mm = pid.substr(0,2) * 1;
            var dd = pid.substr(2,2) * 1;
            var birthDate = yyyy + "-" + mm + "-" + dd;
            
            return ageAtDate(birthDate, parent().currentDate());
        }
    }
    
}

///// Ajax: VIN は独立して動くので LOGIC:neuron.js の部分を内部に持つ
/////////////////////////////////////////////////////////////



var _items;
function setItems(array){
	_items = array;
}
function items(){
	return _items;
}

var _aliases;
function setAliases(array){
	_aliases = array;
}
function aliasForTitle(title){
	return _aliases[title];
}

function putItemList(){
	// アイテムリストを表示する
	if ((xmlHttpObject.readyState == 4) && (xmlHttpObject.status == 200)){
		var value = xmlHttpObject.responseText;
		var array = value.split("<SEPARATOR>");
		if (array.length > 1){
			var elm = document.getElementById("itemSelectorArea");
			elm.innerHTML = "";
			
			// "itemSelectorArea" の上にポップアップメニュー生成
			var items = new Array();
			var aliases = new Array();
			var item = "";
            //alert("putItemList->"+array[1]); //##
            
			var obj = JSON.parse(array[1]);
            //_debug("== putItemList == "+encodeObject(obj)); //##
            
			// obj は {"再診料":"saishin",,} のようなオブジェクトの配列
			for (title in obj){
				var value = obj[title];
                if (title.length ==0) continue;
                
				items.push(title);  // title:"再診料"
				aliases[title] = value; // value:"saishin"
				if (isSame(value, "shoshin")) 
					item = title;
				else if (isSame(value, "saishin")) 
					item = title;
			}
			items.splice(0, 0, "");
			items.push("...その他");
			setItems(items);
			setAliases(aliases);
			
            //alert("putItemList->"+encodeObject(items)); //##
            
			// item 選択ポップアップを表示
			var pu = newPopupMenu(elm, "itemSelector", items, item);
			pu.setAttribute("onchange", "itemSelected()");
			itemSelected();
			
			// 絞り込みフィールドを生成
			makeForcusOnArea();
			
			document.getElementById("message").innerHTML = "";
		}
	}
	else 
		document.getElementById("message").innerHTML = "Loading...";
}
function getItemList(num){
	// 診療行為マトリックスの選択で起動され、該当アイテムリストをリクエスト
	xmlHttpObject = createXMLHttpRequest(putItemList);
	if (xmlHttpObject){ // GETパラメータ付きでリクエスト送信
		var st = "./vinServer.php?command=GET_CHILD_SELECTOR&value="+num;
		//alert("getItemList->"+st); //##
        
		xmlHttpObject.open("GET", encodeURI(st), true);
		xmlHttpObject.send(null);
	}
}

function putItem(){
	// 選択されたアイテムの入力欄を再描画
	if ((xmlHttpObject.readyState == 4) && (xmlHttpObject.status == 200)){
		var value = xmlHttpObject.responseText;
        //alert("putItem->"+value); //##
		
		var array = value.split("<SEPARATOR>");
		if (array.length > 1){
			// array[1] = "_|_21_|_pill_|_低用量ピル_|_28_|_Tab_|_53_|_0"
			// 一括テンプレートの場合は複数レコード
			var records = JSON.parse(array[1]);
            //alert("== putItem == "+encodeObject(records)); //##
            
			// ここでは選択されたアイテムに対するレコードをサーバの PriceList から得たもの
			// なので point * dose 処理がされていない。従って point は全て空にしておく。
			// 空 point だと calc() の時に PriceList の点数で補完される。
            records = pointToEmpty(records);
			
			// code に応じて「数量」「頻度」入力欄を表示
			// records[0] = "1_|_21_|_pill_|_低用量ピル_|_28_|_Tab_|_1060_|_0" 形式
			setCurrentRecords(records);
			showDoseAndFreqField(records[0]);
			
			document.getElementById("message").innerHTML = "";
		} else
			document.getElementById("message").innerHTML = value;
	} else 
		document.getElementById("message").innerHTML = "Loading...";

    function pointToEmpty(records){
        // record 中の point を全て空にする。
        // 空 point だと calc() の時に PriceList の点数で補完される。
        for (num in records){
            // "0_|_21_|_adona30mg_|_アドナ30mg_|_3_|_Tab_|_1_|_12.9_|_0" 形式のレコード
            var rec = records[num];
            rec.point = "";
            /*
            var ln = records[i];
            var array = ln.split("_|_");
            array[7] = ""; // point を空にする
            records[i] = array.join("_|_");
             */
        }
        return records;
    }
}
function getItem(){
	// itemSelector（薬剤名など）が選択された時に作動
	xmlHttpObject = createXMLHttpRequest(putItem);
	
	if (xmlHttpObject){ // GETパラメータ付きでリクエスト送信
        var obj = new Object();
		obj.isOwn = (document.getElementById("isOwn").checked) ? 1 : 0;
        obj.code = groupCode();
		var item = document.getElementById("itemSelector").value;
        obj.alias = aliasForTitle(item);
        obj.owner = parent().owner();

        var st = "./vinServer.php?command=GET_ITEM"
		+ "&value="+encodeSTRING(encodeObject(obj));

        //_debug("== getItem ->"+st); //##
        
		xmlHttpObject.open("GET", encodeURI(st), true);
		xmlHttpObject.send(null);
	}
}

function overlappedItem(){
    // 重複した診療行為があればそれを返し、なければ null を返す
    var obj = new Object();
    var array = itemArray();
    for (num in array){
        var rec = array[num];
        var item = rec.code + ":" + rec.name;

        // item の重複をチェックするため obj の引数にする
        if (obj[item]) return item;

        obj[item] = "dummy";
    }
    return false;
}


function treatmentFormat(obj){
    // NOA へ返送する 診療行為フォーマット に変換
    // "外用[ホーリンV錠 (2 錠)] 220 x 2 自費" のような形式の一行を生成
    var own = (obj.isOwn * 1) ? " 自費" : "";
    
    if (obj.code * 1 == 99){
        return obj.name;
    } else {
        var freq = (obj.freq * 1 > 1) ? " x " + obj.freq : "";
        var cd = codeName(obj.code);
        
        // 混注の子の場合は名称の先頭に "+ " をつける
        var name = (obj.isMix * 1 > 0) ? "+ " + obj.name : obj.name;
        
        // 単位がある場合は (単位数 単位) を表示
        var doseUnit = (obj.unitName.length > 0)
        ? "(" + obj.dose + " " + obj.unitName + ")" : "";
        
        return cd + "[" + name + doseUnit + "] " + obj.point + freq + own;
    }
}

function putResultOfCalc(){
	// 選択されたアイテムを追加しアイテム・リストを再表示
	if ((xmlHttpObject.readyState == 4) && (xmlHttpObject.status == 200)){
		var value = xmlHttpObject.responseText;
        
        //alert("putResultOfCalc->"+value); //##
        
		var array = value.split("<SEPARATOR>");
        var rows = new Array(); // NOA へ返送する文字列レコードを格納
		if (array.length > 1){
			initItemArray();
            var parentRow = (-1);
            var parentPoint;
			var records = JSON.parse(array[1]);
            //alert("putResultOfCalc: records->"+encodeObject(records)); //##
            
            for (num in records){
				var rec = records[num];
				if (rec) {
                    //_debug("rec->"+encodeObject(rec)); //##
                    
                    var obj = newItem(rec); // ここでレコードを itemArray() に追加
                    // obj = "isOwn(0)code(11)alias()name(初診)standard(1)unitName()freq(1)point(270)isMix()"
            
                    // 混注に関する処理を行う
                    if (obj.isMix == "0"){ // 混注の親レコード
                        parentRow = num;
                        parentPoint = obj.point * 1;
                    } else if (obj.isMix * 1 > 0){ // 混注の子レコード
                        parentPoint += obj.point * 1; // 親の点数に子の点数を加算
                        obj.point = ""; // 子の点数は空白にする
                    } else { // 混注ではない
                        if (parentRow >= 0){ // 過去に混注があった
                            var parentObj = itemArray()[parentRow];
                            parentObj.point = parentPoint;
                            parentRow = (-1);
                        }
                    }
             
                    if (obj){
                        rows.push(treatmentFormat(obj)); // NOA へ返送する文字列
                    }
                }
			}
            
            if (parentRow >= 0){ // 過去に混注があった
                var parentObj = itemArray()[parentRow];
                parentObj.point = parentPoint;
            }
		}
        
        // VIN の内容を再表示
		showItemList();

        // 「領収書」ボタンを表示
        showBillButton();
        
		document.getElementById("message").innerHTML = ""; // Ajax に渡す前に実行
        
        // NOA へ結果を返送：Ajax
        var buff = rows.join("<br>");
		parent().gotValueFromTool(buff, vinTouchAndGo(), vinTouchAndPrint());
	} else {
		document.getElementById("message").innerHTML = "Loading...";
    }
}

function timeStamped(answer){
    // 「計算せず」モードで受診レコードの endTime のみが更新された
    //alert("timeStamped->"+answer); //##
    var rows = new Array(); // NOA へ返送する文字列レコードを格納
    var array = treatmentArray();
    for (num in array){
        var obj = array[num]; 
        if (obj)
            rows.push(treatmentFormat(obj)); // NOA へ返送する文字列
    }
    var buff = rows.join("<br>");

    // NOA へ結果を返送：Ajax
    parent().gotValueFromTool(buff, vinTouchAndGo(), vinTouchAndPrint());
}

function calc(){
	// アイテム・リストの計算を vinServer へリクエスト
	// サーバ側で計算結果を FRONT へ転送
    //_initDebug(true); //##
    _debug("== calc =="); //##
    
    var currentDate = parent().currentDate();
    if (isSameDate(todayAndTime(), currentDate) == 0){
        if (!confirm("本日のページではありません。書き換えていいですか？")) 
            return;
    }

    var array = treatmentArray();
    if (array.length == 0){
        if (!confirm("本日も前回と同じ診療行為ですか？"))
            return;
    }
    
    if (checkDiseases()){
        // 病名チェッカーが活きていれば診療行為・病名の対応チェックを行う
        doCheckDiseases()
    }
    
    if (hasFilter()){
        // もしフィルター拡張機能があればフィルタリングを行う
        var array = filter(itemArray());
        _debug("hasVinfilter->"+encodeObject(array)); //##
        
        setItemArray(array);
    }
    
    var item = overlappedItem();
    if (item){
        if (!confirm(item + " が重複しています。このまま計算していいですか？"))
            return;
    }
    
    if (omitCalculate()){
        // 「集計」ボタンで計算せず転記のみ
        
        // FRONT の patientId,entryDate レコードの endTime にタイムスタンプを刻印
		var patientId = parent().patientId();
		var entryDate = parent().currentDate();
        
        NRPutFrontTimestamp(patientId, entryDate, timeStamped);
    } else {
        xmlHttpObject = createXMLHttpRequest(putResultOfCalc);
        if (xmlHttpObject){ // GETパラメータ付きでリクエスト送信
            // buff は itemArray() を encodeItem() で文字列にしたもの
            // これをサーバへ送って計算を依頼する
            var obj = new Object();
            obj.records = array;
            obj.arguments = args();
            var buff = encodeObject(obj);
            
            var st = "./vinServer.php?command=CALC"
            + "&value=" + encodeSTRING(buff);
            
            //_initDebug(true); //##
            _debug("calc->"+st); //##
            
            xmlHttpObject.open("GET", encodeURI(st), true);
            xmlHttpObject.send(null);
        }
    }
}

function puttedHasTax(answer){
    //alert("puttedHasTax->"+answer); //##
}
function putHasTax(){
    // 外税付加の status をサーバへ保存
    var tag = "VIN_PREFERENCE";
    var menuItem = "HAS_TAX";
    var value = (elmFor("hasTax").checked) ? "1" : "0";
    
    NRPutMenu(owner(), tag, menuItem , "", value, puttedHasTax);
}

function gotVinPreference(answer){
    // 初期設定パネルを開く
    var hasTex = false;
    var array = JSON.parse(answer);
    for (num in array){
        var rec = array[num];
        if (rec.menu = "HAS_TAX") hasTex = (rec.value * 1 > 0) ? true : false;
    }
    
    var w = 250;
	var x = 10; // 表示するx座標
	var y = _prefY; // 表示するy座標
    var title = "初期設定";
    var elm = openSeeThroughPanel("_floatPanel", x, y, w, title);
    if (!elm){
        alert("_floatPanel がないのでパネルを表示できません"); return;
    }
    elm.style.padding = "5px";
    
    // 外税
    var div = newDIV(elm, "");
    div.style.fontSize = "10pt";
	var cb = newCHECKBOX(div, "hasTax", " 自費料金に外税を加算", hasTex);
    cb.setAttribute("onchange", "putHasTax()");
}
function getVinPreference(){
    // 初期設定をサーバから読込
    var tag = "VIN_PREFERENCE";
    
    NRGetMenu(owner(), tag, gotVinPreference);
}

///// Ajax による処理 ///////////////
///////////////////////////////////

function selectedChar(ch){
    // 文字選択パネルの文字が選択された
    var fd = elmFor("focusOnF");
    var val = fd.value + ch;
    fd.value = val;
    forcusOn();
}
function showCharPanel(elm){
    // 文字選択パネルを表示
    var pos = getPosition(elm);
    var w = 250;
	var x = pos.x; // 表示するx座標
	var y = pos.y + 25; // 表示するy座標
    var title = "";
    var elm = openSeeThroughPanel("_floatPanel", x, y, w, title);
    if (!elm){
        alert("_floatPanel がないのでパネルを表示できません"); return;
    }
    elm.style.padding = "5px";
    
    var ln = 'abcdefghijklmnopqrstuvwxyz';
    var len = ln.length;
    for (var p=0; p < len; p++){
        var ch = ln.charAt(p);
        if (p % 8 == 0)
            var div = newDIV(elm, "");
        var dv = newDIV(div, "/blueButton");
        dv.innerHTML = ch;
        dv.setAttribute("onclick", "selectedChar('" + ch + "')");
        dv.style.fontSize = "18pt";
        dv.style.fontFamily = "monospace";
    }
}

function forcusOn(){
	// key に一致するメニューだけを表示
	var key = document.getElementById("focusOnF").value;
	
	// key を含むメニューのみに絞り込む
	// ## items() はメニュー表示内容なので alias も保持しておき
	// ## alias も検索対象にできるようにする
	var menuItems = new Array();
	var array = items();
	for (num in array){
		var name = array[num]; // 診療行為の実名
        var alias = aliasForTitle(name); // 実名に対応する alias
        
        // 実名か alias に部分一致したものだけを menuItems に取り込む
		if (alias && (alias.indexOf(key) >= 0)){
			menuItems.push(name);
		} else if (name.indexOf(key) >= 0){
			menuItems.push(name);
        }
	}
	
	// ポップアップメニューを表示
	var elm = document.getElementById("itemSelectorArea");
	elm.innerHTML = "";

	var pu = newPopupMenu(elm, "itemSelector", menuItems, "");
	pu.setAttribute("onchange", "itemSelected()");
	itemSelected();
}
function makeForcusOnArea(){
	// アイテムを絞り込みを行うフィールドを生成
	var elm = document.getElementById("focusOnArea");
    elm.innerHTML = "";
	var fd = newFIELD(elm, "focusOnF", "", 20, "");
	fd.focus();
	fd.setAttribute("onkeyup", "forcusOn()");
    fd.setAttribute("type", "search");
    fd.setAttribute("placeholder", "絞込みキー"); // 入力ヒントを表示
}

function putGlobal(answer){
	// globalList.js から返されるレスポンス
    alert("putGlobal は使われないので無処理"); //##
}
function itemSelected(){
	// itemSelector（薬剤名など）が選択された時に作動
	// ポップアップメニューに表示されたアイテムを default テンプレート名として表示
	var itemName = document.getElementById("itemSelector").value;
	if (itemName == ""){
		hideItemAddButton();
		return;
	} else if (itemName == "...その他"){
		// グローバル辞書からの選択パネルを表示
		// ### globalList からのメッセージは putGlobal() で受ける
		var url = "./globalList.php?code=" + groupCode();
		window.open(url, "globalList"
					, "scrollbars=yes,width=900,height=500");
		return;
	}
	
	// itemSelector がアクティブの時のみ挿入ボタンを表示
	showItemAddButton();
    
	var fd = document.getElementById("templateName");
    //alert("itemSelected->"+itemName+"->"+fd); //##
	
	if (fd) fd.value = itemName; // 一括メニューの場合は fd 存在しない
    
	getItem();
}

function showDoseAndFreqField(rec){
	// 数量・頻度入力欄を表示
	// rec: "1_|_21_|_pill_|_低用量ピル_|_28_|_Tab_|_1_|_1060_|_0" 形式のレコード
	// から default 値を表示
	var elm = document.getElementById("doseAndFreqArea");
	elm.innerHTML = "";

	var code = groupCode() * 1;
    //alert("== showDoseAndFreqField == "+code+"->"+encodeObject(rec)); //##
    
	if (code == 0) return; // 一括メニュー
    
    // treatment 欄からデータ取得した場合 standard は無いので dose を流用
    if (! rec.standard) rec.standard = rec.dose;
	
	switch (code){
		case 21: case 22: case 23:
			showDose(elm, rec.standard, rec.unitName);
			showFeq(elm, code);
			break;
		case 31: case 32: case 33:
			showDose(elm, rec.standard, rec.unitName);
			var cb = newCHECKBOX(elm, "isMix", "を混注の追加薬剤として ", 0);
			break;
	}
	
	function showDose(elm, dose, unitName){
		var fd = newFIELD(elm, "dose", "", 3, dose);
		var tx = newTEXT(elm, unitName);
	}

	function showFeq(elm, code){
		var freq = 5; // ５日分に決め打ち
		var fd = newFIELD(elm, "freq", "", 2, freq);
		var tx = newTEXT(elm, freqName(code));
	}
}

function freqName(code){
    switch (code){
        case 21:
        case 22:
            return "日";
        default:
            return "回";
    }
}

function compareCode(a, b){
    // isOwn code isMix でソート： (a > b) のような比較では正しく動作しない
    return (sortString(a) * 1) - (sortString(b) * 1);

    function sortString(obj){
        // obj からソート用文字列を生成
        // 先頭が "0" だと正しくソートされない
        var isOwn = (obj.isOwn * 1 > 0) ? "2" : "1";
        var isMix = (obj.isMix && (obj.isMix * 1 > 0)) ? "1" : "0";
        
        return isOwn + obj.code + isMix + ""; // 数値として加算されないよう末尾に ""
    }
}
function showItemList(){
	// アイテム・リストを表示
	var elm = document.getElementById("result");
	elm.innerHTML = "";
	
	// タイトル
	var tbl = newTABLE(elm, "/base-table");
	var tr = newTR(tbl, "", "");
    tr.style.color = "#777";
    tr.style.fontSize = "10pt";
	var td = newTD(tr, "title_code", "");
    setInfoTip("title_code", "以下の行を一括消去"); // HELP
    var sp = newSPAN(td, "/codeCol");
    var img = newIMAGE(sp, "icon", "./remove-field.png", "remove");
	img.setAttribute("onclick", "clearItems()");
	img.style.height = "12px";
	img.style.position = "relative";
	img.style.bottom = "1px";
    img.setAttribute("class", "expandIcon");
	var td = newTD(tr, "", "診療行為");
	var td = newTD(tr, "", "数量");
    td.style.textAlign = "center";
	var td = newTD(tr, "", "点数");
    td.style.textAlign = "center";
	var td = newTD(tr, "", "頻度");
    td.style.textAlign = "center";

	// 診療行為コンテンツ
    var sumItem;
    var records = itemArray();
    
    //_debug("records->"+encodeObject(records)); //##
    
    // records を isOwn,code,isMix 順でソート
    records.sort(compareCode);
    
    for (num in records){
        var item = records[num];
        //_debug("showItemList->"+encodeObject(item)); //##

        if (item.code == "0")
            continue;
        if (item.code == "99")
            sumItem = item;
        else {
            // 自費か健保かにより背景色を変える
            var trId = (item.isOwn > 0) ? "jihi" : "record";
            var tr = newTR(tbl, trId, "");
            
            // コード
            var td = newTD(tr, "/codeCol", "");
            var a = newA(td, item.code, "#", "");
            var action = "removeItem('" + item.number + "')";
            a.setAttribute("onclick", action);
            
            // 診療行為名（自動付加のものは背景色を変える）
            var tdId = ((item.code % 10 == 9) || (item.code * 1 == 13))
            ? "subRecord" : "";
            var td = newTD(tr, "/nameCol", "");
            var sp = newSPAN(td, tdId);
            sp.innerHTML = (item.isMix > 0) ? "+ " + item.name : item.name;
            // コード種別ごとに背景色を変える
            switch (String(item.code).substr(0, 1) * 1){
                case 4: sp.setAttribute("class", "shochi"); break;
                case 6: sp.setAttribute("class", "kensa"); break;
            }
            
            // 数量・単位
            var td = newTD(tr, "/doseCol", "");
            if ((item.code != 60) && (item.unitName.length)){
                var ary = item.unitName.split(" ");
                var fd = newFIELD(td, num + ".dose", "", 2, item.dose);
                fd.setAttribute("onchange", "doseChanged('" + num +"')");
                fd.style.textAlign = "right";
                var tx = newTEXT(td, item.unitName);
            }
            
            // 点数：ここに表示されるものは、薬価 * 数量なので注意
            // addItem() で PriceList を元に挿入されたものは空 point
            // calc() や getHeader() で取り込まれたものは point * dose 処理済み
            var td = newTD(tr, "", item.point + ""); // 数値のことがあるので文字列へ
            td.setAttribute("class", "pointCol");
            
            // 頻度
            var td = newTD(tr, "freqF/freqCol", "");
            td.style.paddingRight = "5px";
            var fname = freqName(item.code * 1);
            var freq = (item.isMix > 0) ? "" : item.freq;
            var fd = newFIELD(td, num + ".freq", "", 2, freq);
            fd.setAttribute("onchange", "freqChanged('" + num +"')");
            fd.style.textAlign = "right";
            var tx = newTEXT(td, fname);
        }
        //_debug("--- row end ---------------<br>"); //##
    }
	// 合計
	if (sumItem){
		// 合計についてはフォーマットが異なり item.name の中に入っている
		// "_|_99_|__|_合計[健保(686 x 3 = 2050)自費(5400)] 7450_|__|__|__|_"
		var tr = newTR(tbl, "sum", "");
		var td = newTD(tr, "", sumItem.name);
		td.setAttribute("colspan", "5");
	}
	
	// 絞込みフィールドをフォーカス
	var fd = document.getElementById("focusOnF");
	if (fd) fd.focus();
    
    // 診療行為に変更が加えられたので「集計」されるまで「領収書」ボタンを表示しない
    hideBillButton();
}

function clearItems(){
	// アイテム・リストをクリアする
	initItemArray();
	showItemList();
}

function removeItem(number){
	var item = itemWithId(number);
	// if (!confirm(item.name + "を削除します")) return;
	
	removeItemArray(number);
	showItemList();
}

function hideItemAddButton(){
	document.getElementById("itemAddButtonArea").innerHTML = "";
}
function showItemAddButton(){
	var sp = document.getElementById("itemAddButtonArea");
	sp.innerHTML = "";
    sp.style.marginLeft = "5px";
	var bt = newDIV(sp, "/whiteButton");
    bt.innerHTML = "挿入";
	bt.setAttribute("onclick","addItem()");
}
function addItem(){
	// 選択・編集されたアイテムを診療行為リストに追加する
	// "1_|_21_|_pill_|_低用量ピル_|_28_|_Tab_|_1_|_1060_|_日分_|_" 形式のレコード
	// これを元に item オブジェクトを生成し currentItem に記憶
	var records = currentRecords();
    _debug("== addItem->"+encodeObject(records)); //##

	if (records.length == 1){
		// 一括メニューでない場合
        var rec = records[0];
        rec.isOwn = (document.getElementById("isOwn").checked) ? 1 : 0;
		var elm = document.getElementById("dose");
        rec.dose = (elm) ? elm.value : "1";
		var elm = document.getElementById("isMix");
        rec.isMix = (elm && elm.checked) ? 1 : 0;
		var elm = document.getElementById("freq");
        rec.freq = (elm) ? elm.value : "1";
        // まだ rec.point は計算処理されていないので見せない
	}
	
    for (num in records){
		// 一括メニュー(約束処方)の場合は、診療行為に複数を追加する
		var rec = records[num];
        rec.isOwn = (document.getElementById("isOwn").checked) ? 1 : 0;
		var item = newItem(rec);
	}
	
    closeFloatPanel(); // 文字パネルを閉じる
	
	showItemList();
}

/////////////////////////////////////////////////////////////
/////// テンプレート編集ペーン //////////////////////////////////

function closeTEmplateEditor(){
	document.getElementById("templateArea").innerHTML = "";
}

function openTemplateEditor(){
	// テンプレート編集ペーンを開く
	var elm = document.getElementById("templateArea");
	if (elm.innerHTML.length > 0){
		elm.innerHTML = "";
		return;
	}
    
    var frame = newDIV(elm, "templateFrame");

    // HEADER
    var div = newDIV(frame, "");
    var dv = newDIV(div, "left-side");
	dv.innerHTML = "上記セットを一括入力へ登録";
    var dv = newDIV(div, "right-side");
	var im = newIMAGE(dv,"icon","./close.png","close");
	im.setAttribute("onclick", "closeTEmplateEditor()");
    im.setAttribute("class", "expandIcon");

    var div = newDIV(frame, "");
    div.style.clear = "both";
    div.style.paddingBottom = "5px";
	// 約束処方名入力（一括メニューが開いていればそのメニュー・アイテムを default 表示）
	var gcode = groupCode() * 1;
	var popup = document.getElementById("itemSelector");
	var menuItem = (popup && (gcode == 0)) ? popup.value : "";
    var dv = newDIV(div, "");
    dv.style.paddingLeft = "10px";
	var fd = newFIELD(dv, "templateName", "一括名", 20, menuItem);
    fd.focus();
	var bt = newDIV(dv, "/whiteButton");
    bt.innerHTML = "登録";
	bt.setAttribute("onclick", "saveTemplate()");
}

/////// テンプレート編集ペーン //////////////////////////////////
/////////////////////////////////////////////////////////////

function showBillButton(){
    // 「領収書」ボタンを表示
	var elm = document.getElementById("billButtonArea");
    elm.innerHTML = "";
	var bt = newDIV(elm, "/whiteButton");
    bt.innerHTML = "領収書";
	bt.setAttribute("onclick","printBill()");
}
function hideBillButton(){
    // 「領収書」ボタンを削除
	var elm = document.getElementById("billButtonArea");
    elm.innerHTML = "";
}

function printBill(){
    // 領収明細書を発行
	var obj = new Object();
    obj.currentDate = parent().currentDate();
    obj.publishedDate = today();
    obj.patientId = parent().patientId();
    obj.patientName = parent().patientKanjiName();
    obj.insuranceClass = _valueForTag("HealthInsurance.shubetsu");
    obj.paymentRatio = _valueForTag("HealthInsurance.paymentRatio");
    var st = _valueForTag("PatientTable.unpaid"); // "timeStamp,unpaid" 形式
    var array = st.split(",");
    obj.unpaidFee = (array.length > 1) ? array[1] : "0";
    obj.discountRatio = _valueForTag("HealthInsurance.discountRatio");

    // VIN の医事計算レコードをスキャン
    var point = 0;
    var ownFee = 0;
    var count = countOfItemArray();
	if (count > 0){
        obj.ins = new Object();
        obj.own = new Object();
        for (var i=0; i < count; i++){
            var item = itemAtIndexOf(i);
            var code = Math.floor(item.code / 10) * 10; // "12" を "10" にする
            var freq = (item.freq) ? item.freq : 1;
            if (item.isOwn > 0){
                if (!obj.own[code]) obj.own[code] = 0;
                // code 毎の自費点数を加算
                obj.own[code] += item.point * freq;
                ownFee += item.point * freq;
            } else {
                if (!obj.ins[code]) obj.ins[code] = 0;
                // code 毎の健保点数を加算
                obj.ins[code] += item.point * freq;
                point += item.point * freq;
            }
        }
    }
    obj.round = parent().hospitalInfoForKey("まるめ係数") * 1;
    obj.point = point;
    obj.insFee = point * obj.paymentRatio + obj.round;
    obj.insFee = Math.floor(obj.insFee / 10) * 10;
    obj.ownFee = ownFee;
    obj.ownRate = parent().hospitalInfoForKey("自費係数") * 1;
    obj.hospitalAddress = parent().hospitalInfoForKey("住所");
    obj.hospitalName = parent().hospitalInfoForKey("施設名");
    obj.hospitalPhone = parent().hospitalInfoForKey("電話番号");

	var url = "./printBill.php?value=" + JSON.stringify(obj);
    
    //_initDebug(true); //##
    //_debug(url); //return; //##
	
	window.open(url, "BILL", "width=650,height=800,dependent=yes");
    
    function _valueForTag(tag){
        var obj = parent().valueForTag(tag);
        return (obj) ? obj.value : "";
    }
}

/////////////////////////////////////////////////////
///// 初期設定 ///////////////////////////////////////

var _prefY;
function openVinPreference(elm){
    // 初期設定を開く
    var pos = getPosition(elm);
    _prefY = pos.y;
    
    getVinPreference();
 /*   
    var w = 250;
	var x = 10; // 表示するx座標
	var y = pos.y; // 表示するy座標
    var title = "初期設定";
    var elm = openSeeThroughPanel("_floatPanel", x, y, w, title);
    if (!elm){
        alert("_floatPanel がないのでパネルを表示できません"); return;
    }
    elm.style.padding = "5px";
    
    // 外税
    var div = newDIV(elm, "");
    div.style.fontSize = "10pt";
	var cb = newCHECKBOX(div, "hasTax", " 自費料金に外税を加算", 0);
    cb.setAttribute("onchange", "putHasTax(cb)");
  */
}

///// 初期設定 ///////////////////////////////////////
/////////////////////////////////////////////////////


function openPliceList(){
    // PriceList を開く
	window.open("../NOAManager/priceList.php?mode=NOA","PriceList");
}

function calcChecker(){
    // 診療行為と病名との突合チェッカーを開く
    openCalcChecker();
}

function vinHelp(){
	var win = window.open("./vinHelp.html","Help"
						  ,"width=450,height=700,scrollbars=yes,resizable=yes");
	win.focus();
}

function initVin(){
    //_initDebug(true); //##

	var elm = document.getElementById("base");
	
    // === HEADER ============================
    var div = newDIV(elm, "/tool-header");
    var dv = newDIV(div, "/left-side");
    dv.innerHTML = "診療入力";
    dv.style.width = "200px";
    dv.style.fontSize = "10pt";
    var dv = newDIV(div, "/right-side");
    // VERSION
	var sp = newSPAN(dv, "");
    sp.innerHTML = version();
    sp.style.paddingRight = "5px";
    sp.style.color = "#aaa";
    sp.style.fontSize = "9pt";
    
	var im = newIMAGE(dv, "", "./help.png", "?");
	im.setAttribute("onclick", "vinHelp()");
	im.setAttribute("verticalAlign", "middle");
	im.style.height = "16px";
	im.style.position = "relative";
	im.style.top = "3px";
    im.setAttribute("class", "expandIcon");

	// --- 診療マトリックス表示・エリア ---------------
    var div = newDIV(elm, "matrixArea");

	// --- 時間帯・自費チェックボックス ---------------
    var div = newDIV(elm, "controlBox");
    var tbl = newTABLE(div, "base-table");
	tbl.style.fontSize = "8pt";
	var tr = newTR(tbl, "", "");
	var td = newTD(tr, "", "");
	var cb = newCHECKBOX(td, "isOwn", "自費 ", 0);
	var js = newSPAN(td, "timeZoneArea");
	// 絞り込みボタン・エリア
	var sp = newSPAN(td, "focusOnArea");
	// 処置内容選択エリア
	var tr = newTR(tbl, "", "");
	var td = newTD(tr, "itemSelectorArea", "");
	td.style.padding = "0px 5px";
	// 診療行為名・挿入ボタン
	var tr = newTR(tbl, "", "");
	var td = newTD(tr, "", "");
	td.style.padding = "0px 5px";
	var sp = newSPAN(td, "doseAndFreqArea");
	var sp = newSPAN(td, "itemAddButtonArea");
    
	// --- 診療行為表示・エリア：診療行為行を列記するエリア
    var div = newDIV(elm, "result");
	
    // === FOOTER =====================
    var div = newDIV(elm, "vin-footer");
    div.style.height = "25px";
    var dv = newDIV(div, "/left-side");
    dv.style.width = "80%";
    dv.style.marginTop = "3px";
    dv.style.paddingLeft = "5px";
    dv.style.fontSize = "9pt";
	var bt = newDIV(dv, "/fixButton");
    bt.innerHTML = "集計";
	bt.setAttribute("onclick","calc()");
    var sp = newSPAN(dv, "billButtonArea");
    var sp = newSPAN(dv, "");
    var cb = newCHECKBOX(dv, "vinTouchAndGoCB", "確定保存", vinTouchAndGo());
    cb.setAttribute("onchange", "setVinTouchAndGo(this)");
    setInfoTip("vinTouchAndGoCB", "集計とともに「診療」欄を保存"); // HELP
    var sp = newSPAN(dv, "");
    var cb = newCHECKBOX(dv, "vinTouchANdPrintCB", "確定印刷", vinTouchAndPrint());
    cb.setAttribute("onchange", "setVinTouchAndPrint(this)");
    setInfoTip("vinTouchANdPrintCB", "集計とともにページ印刷"); // HELP
    var sp = newSPAN(dv, "");
    var cb = newCHECKBOX(dv, "omitCalculate", "計算せず", omitCalculate());
    cb.setAttribute("onchange", "setOmitCalculate(this)");
    setInfoTip("omitCalculate", "計算せず診療行為の転記のみ"); // HELP
    var dv = newDIV(div, "/right-side");
    /*
    var img = newIMAGE(dv, "icon", "./hammer.png", "remove");
	img.setAttribute("onclick", "openVinPreference(this)");
	img.style.height = "12px";
	img.style.position = "relative";
	img.style.top = "5px";
    img.setAttribute("class", "expandIcon");
     */

	// アンカー・エリア
	var div = newDIV(elm, "anchor");
    var ul = newUL(div, "");
    ul.setAttribute("class", "listMembers");
    var li = newLI(ul, "PriceList");
    li.setAttribute("class", "listMember");
	li.setAttribute("onclick", "openPliceList()");
    var li = newLI(ul, "セット登録");
    li.setAttribute("class", "listMember");
	li.setAttribute("onclick", "openTemplateEditor()");
    var li = newLI(ul, "フィルター");
    li.setAttribute("class", "listMember");
    li.setAttribute("onclick", "openFilter()");
    var li = newLI(ul, "病名チェッカー");
    li.setAttribute("class", "listMember");
    li.setAttribute("onclick", "calcChecker()");
    
	// --- テンプレート登録時にテンプレート名入力欄を表示するためのエリア
    var div = newDIV(elm, "templateArea");
	
	getHeader();
}

function version(){
	return "Ver.140227";
}


